

package Reflecter;

public class ReflecterTest
{


	public static int test()
	{
		Reflecter_Interface ri = new ReflecterReflection();
		Object ret;
		
		Object[] args = new Object[1];
		args[0] = new String("HelloReflecter!");

	
		ret = ri.invoke("Reflecter.ReflecterCoTest", "static_test", args);
		System.out.println("static_test() returned " + ret );

		ret = ri.invoke("Reflecter.ReflecterCoTest", "non_static_test", args);
		System.out.println("non_static_test() returned " + ret );

		ret = ri.invoke("Reflecter.ReflecterCoTest", "test3", null);
		System.out.println("non_static_test() returned " + ret );
	

		ReflecterCoTest rct = new ReflecterCoTest();
		rct.member = 7;
		ri.invoke( rct, "test3", null);

		args[0] = new TestInterfaceClass();
		ri.invoke( "Reflecter.ReflecterCoTest", "interface_test", args );

		return 0;
	}

	public static void main(String[] args)
	{
		for(int i=0; i < 1; i++)
		{
			test();
		}
	}

}

class ReflecterCoTest
{

	int member = 2;

	public static int static_test(String message)
	{
		System.out.println("static_test() " + message);
		return 1;
	}

	public int non_static_test(String message)
	{
		static_test( message );
		return 2;
	}

	public int test3()
	{
		static_test("static\bh member = " + member );
		return 3;
	}

	public int interface_test(TestInterface ti)
	{
		static_test("C^[tF[XeXg str = " + ti.str );
		return 4;
	}

}


class		TestInterfaceClass implements TestInterface
{

}

interface	TestInterface
{
	public final String	str	= "TestInterface";
}
