
import java.util.*;
import jnios.*;



/*

萔lŁA2 (= AF_INET)
*/

public class SocketTest
{

	public static void startConnection()
	{

		Server svr = new Server();
		svr.start();

		try {
			Thread.sleep(1000);
		} catch (Exception e ) {
			e.printStackTrace();
		}


		Client clt = new Client();
		clt.start();
	}


	public static void main(String[] args)
	{
		
		SocketTest st = new SocketTest();
		
		st.startConnection();

	}


}

class Server extends Thread
{

	public void run()
	{

		this.startTCPServer();

	}

	public static int startTCPServer()
	{
		int fd;

		//int listen_fd  = posix.socket(2, 1, 0);

		int listen_fd = posix.socket( (int)posix.getSocketConstValue("AF_INET"),
					(int)posix.getSocketConstValue("SOCK_STREAM"),
					(int)posix.getSocketConstValue("IPPROTO_TCP") );

		long[] addrArr = new long[10];
		byte[] recvBuf = new byte[1024];



		//posix.bind(2, listen_fd, 0, 8888, 32);
		//addrArr[0] = 2; //AF_INET
		addrArr[0] = posix.getSocketConstValue("AF_INET"); //Ǝ֐
		addrArr[1] = posix.inetaddr("127.0.0.1");
		addrArr[2] = posix.htons(8888);
		posix.bind(listen_fd, addrArr);

		posix.listen(listen_fd, 0);

		addrArr[0] = 2;
		addrArr[1] = 0;
		addrArr[2] = 0;

		fd = posix.accept(listen_fd, addrArr);

		while (true)
		{

			posix.recv(fd, recvBuf, 1024, 0);
			
			//System.out.println("TCP Server recv buf[0] = " + recvBuf[0] + "\n");
			
			try {
				Thread.sleep(1000);
			} catch (Exception e ) {
				e.printStackTrace();
			}

		}

		//return 0;

	}
}


class Client extends Thread
{
	public void run()
	{
		this.startTCPClient();
	}

	public static int startTCPClient()
	{

		long[] addrArr = new long[10];
		byte[] sendBuf = {2, 1, 3, 8, 8, 9, 5, 1};

		addrArr[0] = posix.getSocketConstValue("AF_INET"); //Ǝ֐
		addrArr[1] = posix.inetaddr("127.0.0.1");//127.0.0.1
		addrArr[2] = posix.htons(8888);


		//int fd = posix.socket(2, 1, 0);
		int fd = posix.socket( (int)posix.getSocketConstValue("AF_INET"),
					(int)posix.getSocketConstValue("SOCK_STREAM"),
					(int)posix.getSocketConstValue("IPPROTO_TCP") );
		
		posix.connect( fd, addrArr );

		while ( true)
		{

			posix.send(fd, sendBuf, sendBuf.length, 0);
			
			try {
				Thread.sleep(1000);
			} catch ( Exception e) {
				e.printStackTrace();
			}

		}
		
	}

}


	